#!/bin/sh
#------------------------------------------------------------------------------
# main_Vbox.cgi - display vbox status and calls
# 
# Based on the previous main_Vbox.cgi, created by tg/cp
#
# Creation:     12.06.2003  aw
# Last Update:  26.06.2003  aw
#
#------------------------------------------------------------------------------

. /var/run/vbox.conf

SEC_REALM='misc'
SEC_ACTION='vbox'
. sec-lib.cgi

RTIME=10

myname=`basename $0`


# header [refresh]
# 
# Builds the http and html page header and optionally
# inserts a meta refresh tag to automatically reload
# a given URL

header ()
{
  echo "Content-Type: text/html; charset=iso-8859-1"
  echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
  echo "Pragma: no-cache"        # HTTP/1.0
  echo "Expires: `date -Ru`"     # Expires now!
  if [ "$1" != "" ]
  then
    echo "Refresh: 2; url=$1"
  fi
  echo
  echo "<html>"
  echo "<head>"
  echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"main.css\">"
  echo "</head>"
  echo "<body>"
  echo "<h1>vbox</h1>"
}

# start [num]
#
# Starts the specified vbox

start ()
{
  rm /var/run/vbox_stop_$1 2>/dev/null
}

# stop [num]
#
# Stops the specified vbox

stop ()
{
  if ps|grep "vboxgetty -d /dev/ttyI$1" |grep -qv grep
  then
    echo >/var/run/vbox_stop_$1
    kill `cat /var/run/vboxgetty-ttyI$1.pid`
    rm /var/run/vboxgetty-ttyI$1.pid
  fi
}


# Check, if vbox is running

if [ -f /etc/vbox/vboxgetty.conf ]
then
  if [ "$QUERY_STRING" = "" ]
  then
    header
    
    echo "<p><a href=\"$myname?stopall\">Stop all</a>&nbsp;|&nbsp;<a href=\"$myname?startall\">Start all</a></p>"
    
    psout=`ps`
    i='0'
    while [ $i -lt $VBOX_USERS_N ]
    do
      i=`/usr/bin/expr $i + 1`
      set `eval echo '$VBOX_USERNAME_'$i`
      USRNAME=$1
      SPOOLDIR=/var/spool/vbox/$USRNAME/incoming
      
      echo "<h2>$USRNAME</h2>"
      
      echo "<p><table cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr><td valign=\"top\">"\

      # Show list of users incoming messages
      
      echo "<p><table border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#000000\">"
      echo "<tr bgcolor=\"#ffffc0\"><th>Date</th><th>Caller Name</th><th>Caller ID</th><th>Length</th><th>Action</th></tr>"
      
      ROWCOLOR="#e9e9e9"
      MSGLIST=`ls -r $SPOOLDIR`
      for MSG in $MSGLIST
      do
        if [ "$QUERY_STRING" = "" ] ; then
	  MSGFILE="$SPOOLDIR/$MSG"
	  MSGINFO=`vboxmode $MSGFILE | sed '
            s/.*\.\.\.: //
	    '`
	  
          if [ "$ROWCOLOR" = "#ffffff" ]
          then
            ROWCOLOR="#e9e9e9"
          else
            ROWCOLOR="#ffffff"
          fi
	  
	  j='1'
	  echo "$MSGINFO" |
	  (
            while read MSGVAL
   	    do
	      case $j in
	        2 )
                  infodate=`echo $MSGVAL | /usr/local/htdocs/l2sdate.cgi`
	        ;;
	        4 )
	          infolen=`echo "$MSGVAL" | sed s/" seconds"//"`
	        ;;
	        5 )
	          infoname="$MSGVAL"
	        ;;
	        6 )
	          infocid="$MSGVAL"
	        ;;
	      esac
	      j=`/usr/bin/expr $j + 1`
	    done
	    
	    echo "<tr bgcolor=\"$ROWCOLOR\">"\
	      "<td align=\"right\"><nobr>$infodate</nobr></td>"\
	      "<td><nobr>$infoname</nobr></td>"\
	      "<td align=\"right\"><nobr>$infocid</nobr></td>"\
	      "<td align=\"right\"><nobr>$infolen&nbsp;&nbsp;</nobr></td>"\
              "<td align=\"center\"><a href=\"$myname?play=$MSGFILE\">Play</a>&nbsp;&nbsp;<a href=\"$myname?info=$MSGFILE\">Info</a>&nbsp;&nbsp;<a href=\"$myname?del=$MSGFILE\">Delete</a></td>"\
 	      "</tr>"
	  )
        fi
      done
      
      echo "</table></p>"
      
      echo "</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td valign=\"top\">"
      
      
      # Show status of users MSNs
      
      echo "<p><table border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#000000\">"
      echo "<tr bgcolor=\"#ffffc0\"><th>MSN</th><th>Status</th><th>Action</th></tr>"
            
      j=$VBOX_TTYI_MIN

      while [ $j -lt $VBOX_TTYI_N ]
      do
        set `eval echo '$VBOX_TTYI_'$j`
        
        if [ "$2" = "$USRNAME" ]
        then
          if echo $psout |grep "vboxgetty -d /dev/ttyI$j" |grep -qv grep
          then
            status="running"
            startstopurl="<a href=\"$myname?stop=$j\">stop</a>"
            color="#00FF00"
          else
            status="stopped"
            startstopurl="<a href=\"$myname?start=$j\">start</a>"
            color="#FF0000"
          fi
          
          echo "<tr bgcolor=\"#ffffff\">"\
            "<td bgcolor=\"$color\">$1</td>"\
            "<td bgcolor=\"$color\">$status</td>"\
            "<td align=\"center\">$startstopurl</td></tr>"
        fi
        j=`/usr/bin/expr $j + 1`
      done
     
      echo "</table>"
      
      echo "</td><tr></table></p>"
    done
    
    echo "</body></html>"
  else
    case $QUERY_STRING in
      play=* )
        MSG=`echo $QUERY_STRING | sed s/play=//`
	echo "Content-type: audio/basic"
        echo "Content-Disposition: attachment; filename=vbox.au"
	echo
	touch $MSG -d 1970-01-01
	vboxtoau <$MSG
      ;;
      info=* )
        MSG=`echo $QUERY_STRING | sed s/info=//`
	header
	MSGINFO=`vboxmode $MSG`
	echo "<p><pre>$MSGINFO</pre></p>"
	echo "<p><a href=\"$myname\">Back</a>"
      ;;
      del=* )
        MSG=`echo $QUERY_STRING | sed s/del=//`
	header
	MSGINFO=`vboxmode $MSG`
	echo "<p><pre>$MSGINFO</pre></p>"
	echo "<p>Really delete this message?</p>"
	echo "<p><a href=\"$myname?delc=$MSG\">Yes</a>&nbsp;|&nbsp;<a href=\"$myname\">No</a>"
      ;;
      delc=* )
        MSG=`echo $QUERY_STRING | sed s/delc=//`
	header $myname
	rm $MSG
	echo "<p>Message deleted!</p>"
	echo "<p><a href=\"$myname\">Back</a>"
      ;;
      start=[0-9]* )
        BOX="`echo $QUERY_STRING | sed s/start=//`"
        start $BOX
        sleep 2
        header $myname
        echo "<p>Box started</p>"
	echo "<p><a href=\"$myname\">Back</a>"
      ;;
      stop=[0-9]* )
        BOX="`echo $QUERY_STRING | sed s/stop=//`"
        stop $BOX
        sleep 2
        header $myname
        echo "<p>Box stopped</p>"
	echo "<p><a href=\"$myname\">Back</a>"
      ;;
      "startall" )
        i=$VBOX_TTYI_MIN
        while [ $i -lt $VBOX_TTYI_N ]
        do
          start "$i"
          i=`expr $i + 1`
        done
        sleep 2
        header $myname
        echo "<p>All boxes started</p>"
	echo "<p><a href=\"$myname\">Back</a>"
      ;;
      "stopall" )
        i=$VBOX_TTYI_MIN
        while [ $i -lt $VBOX_TTYI_N ]
        do
          stop "$i"
          i=`expr $i + 1`
        done
        sleep 2
        header $myname
        echo "<p>All boxes stopped</p>"
	echo "<p><a href=\"$myname\">Back</a>"
      ;;
    esac   
  fi
else
  echo "vbox not available!"
fi
